-- This file is part of the it-crafts software and is subject to copyright protection.
-- (C) 2022..2026, All rights reserved by Steffen Anders, Elsteraue - Germany
-- Visit also https://www.it-crafts.de.
--

IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_UsageStatistic')
BEGIN
CREATE TABLE [dbo].[ut_UsageStatistic]
(
  [RecId]  integer NOT NULL
 ,[Module] char(20) DEFAULT ''
 ,[Action] char(20) DEFAULT ''
 ,[LastDate] datetime DEFAULT CONVERT(datetime,'1900-01-01',120)
 ,[Counter] integer DEFAULT 0
  CONSTRAINT [Pk_UsageStatistic]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO

-- drop obsolete triggers and the triggered table with keyvalues
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_UsageStatistic_KeyDel')
  DROP TRIGGER [dbo].[tr_UsageStatistic_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_UsageStatistic_KeyUpd')
  DROP TRIGGER [dbo].[tr_UsageStatistic_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_UsageStatistic_Keys')
  DROP TABLE [dbo].[ut_UsageStatistic_Keys]
GO

-- add new fields
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Module')
BEGIN
  ALTER TABLE [dbo].[ut_UsageStatistic] ADD [Module] char(20) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Action')
BEGIN
  ALTER TABLE [dbo].[ut_UsageStatistic] ADD [Action] char(20) NOT NULL DEFAULT ''
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'LastDate')
BEGIN
  ALTER TABLE [dbo].[ut_UsageStatistic] ADD [LastDate] datetime NOT NULL DEFAULT CONVERT(datetime,'1900-01-01',120)
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Counter')
BEGIN
  ALTER TABLE [dbo].[ut_UsageStatistic] ADD [Counter] integer NOT NULL DEFAULT 0
END
GO

-- check lengths of text fields
IF (20 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Module'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Module'))
BEGIN
   ALTER TABLE [dbo].[ut_UsageStatistic] ALTER COLUMN [Module] char(20)
END
GO
IF (20 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Module'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Module'))
BEGIN
   ALTER TABLE [dbo].[ut_UsageStatistic] ALTER COLUMN [Module] varchar(20)
END
GO
IF (20 > (select sc.length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Action'))
  AND (175 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Action'))
BEGIN
   ALTER TABLE [dbo].[ut_UsageStatistic] ALTER COLUMN [Action] char(20)
END
GO
IF (20 > (select length from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Action'))
  AND (167 = (select sc.xtype from syscolumns sc inner join sysobjects so on sc.[id] = so.[id] and so.[name] = 'ut_UsageStatistic' and sc.[name] = 'Action'))
BEGIN
   ALTER TABLE [dbo].[ut_UsageStatistic] ALTER COLUMN [Action] varchar(20)
END
GO

-- create dedicated view
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'UsageStatistic')
  DROP VIEW [dbo].[UsageStatistic]
GO
CREATE VIEW [dbo].[UsageStatistic] AS
  SELECT [RecId]
 ,[Module]
 ,[Action]
 ,[LastDate]
 ,[Counter]
  FROM [dbo].[ut_UsageStatistic]
GO


-- create function to get the next RecId
IF OBJECT_ID (N'itcfunc_NextRecId_UsageStatistic', N'FN') IS NOT NULL
  DROP FUNCTION dbo.itcfunc_NextRecId_UsageStatistic
GO
CREATE FUNCTION dbo.itcfunc_NextRecId_UsageStatistic() RETURNS integer
AS
BEGIN
  RETURN isnull((SELECT MAX(RecId) FROM [dbo].[ut_UsageStatistic] WITH (READUNCOMMITTED)),0) + 1
END
GO

-- select with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Sel_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Sel_UsageStatistic]  @mRI integer
AS
  SELECT
    [Module]
   ,[Action]
   ,[LastDate]
   ,[Counter]
  FROM [dbo].[ut_UsageStatistic] WHERE RecId = @mRI
GO

-- select with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel2_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Sel2_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Sel2_UsageStatistic]  @Param_RecId varchar(20)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  SELECT * FROM [dbo].[UsageStatistic] WHERE RecId = @mRI
GO

-- insert with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Append_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Append_UsageStatistic]
   @Param_Module char(20)
  ,@Param_Action char(20)
  ,@Param_LastDate datetime
  ,@Param_Counter integer
AS
  DECLARE @NeueId integer
  DECLARE @m_CountDown integer = 10
  WHILE @m_CountDown > 0 BEGIN
    BEGIN TRANSACTION
    BEGIN TRY
      SET @NeueId = dbo.itcfunc_NextRecId_UsageStatistic()
      INSERT INTO [dbo].[ut_UsageStatistic] (RecId
        ,[Module]
        ,[Action]
        ,[LastDate]
        ,[Counter]
          ) VALUES (@NeueId
        ,UPPER(RTRIM(@Param_Module))
        ,UPPER(RTRIM(@Param_Action))
        ,@Param_LastDate
        ,@Param_Counter
          )
      COMMIT TRANSACTION
    END TRY
    BEGIN CATCH
      ROLLBACK TRANSACTION
      SET @NeueId = 0
    END CATCH

    IF @NeueId <> 0
      SET @m_CountDown = 0
    ELSE
      SET @m_CountDown = @m_CountDown - 1

    IF @m_CountDown > 0
      WAITFOR DELAY '00:00:00.050'
  END -- WHILE
  SELECT @NeueId AS RecId
GO

-- insert with obsolete clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Add_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Add_UsageStatistic]
AS
  DECLARE @NeueId integer = dbo.itcfunc_NextRecId_UsageStatistic()
  INSERT INTO [dbo].[ut_UsageStatistic] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
    SELECT @NeueId AS RecId
  ELSE
    SELECT 0 AS RecId
GO

-- update with classic client
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Upd_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Upd_UsageStatistic] @mRI integer
  ,@Param_Module char(20)
  ,@Param_Action char(20)
  ,@Param_LastDate datetime
  ,@Param_Counter integer
AS
  UPDATE [dbo].[ut_UsageStatistic] SET
    [Module] = UPPER(RTRIM(@Param_Module))
   ,[Action] = UPPER(RTRIM(@Param_Action))
   ,[LastDate] = @Param_LastDate
   ,[Counter] = @Param_Counter
  WHERE RecId = @mRI
GO

-- update with modern clients
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd2_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Upd2_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Upd2_UsageStatistic] @Param_RecId varchar(20)
  ,@Param_Module varchar(20)
  ,@Param_Action varchar(20)
  ,@Param_LastDate varchar(10)
  ,@Param_Counter varchar(8)
AS
  DECLARE @mRI integer = dbo.itcfunc_integer(@Param_RecId)
  UPDATE [dbo].[ut_UsageStatistic] SET
    [Module] = UPPER(RTRIM(@Param_Module))
   ,[Action] = UPPER(RTRIM(@Param_Action))
   ,[LastDate] = dbo.itcfunc_datetime(@Param_LastDate)
   ,[Counter] = dbo.itcfunc_integer(@Param_Counter)
  WHERE RecId = @mRI

  EXECUTE [dbo].[up_Sel2_UsageStatistic] @mRI
GO

-- delete
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Del_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Del_UsageStatistic] @mRI integer
AS
  DELETE FROM [dbo].[ut_UsageStatistic] WHERE RecId = @mRI
GO

-- text index
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_UsageStatistic')
  DROP PROCEDURE [dbo].[up_TrSel_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_TrSel_UsageStatistic]
AS
  SELECT RecId,
    LTRIM(RTRIM([Module]))
   +LTRIM(RTRIM([Action]))
  AS Data FROM [dbo].[ut_UsageStatistic] WHERE RecId > 0 ORDER BY RecId
GO

-- reindex
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_UsageStatistic')
  DROP PROCEDURE [dbo].[up_Reorg_UsageStatistic]
GO
CREATE PROCEDURE [dbo].[up_Reorg_UsageStatistic] @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_UsageStatistic] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_UsageStatistic] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_UsageStatistic] )
  END
GO

-- logical key  ORDER BY Module,Action,RecId
IF 0 < (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_UsageStatistic' and so.[id] = si.[id] and si.[name] = 'Ik_Key00')
  DROP INDEX [Ik_Key00] ON [dbo].[ut_UsageStatistic]
GO
IF 0 = (select count(*) from sysindexes si inner join sysobjects so on so.[xtype] = 'U' and so.[name] = 'ut_UsageStatistic' and so.[id] = si.[id] and si.[name] = 'Ik_Key00')
  CREATE INDEX [Ik_Key00] ON [dbo].[ut_UsageStatistic] (Module,Action,RecId)
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_First_UsageStatistic_Key00]
GO
CREATE PROCEDURE [dbo].[up_First_UsageStatistic_Key00] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) ORDER BY Module,Action,RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_First_UsageStatistic_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_First_UsageStatistic_Key00] AS EXECUTE [dbo].[up_First_UsageStatistic_Key00]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_Last_UsageStatistic_Key00]
GO
CREATE PROCEDURE [dbo].[up_Last_UsageStatistic_Key00] AS
  SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) ORDER BY Module desc,Action desc,RecId desc
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Last_UsageStatistic_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_Last_UsageStatistic_Key00] AS EXECUTE [dbo].[up_Last_UsageStatistic_Key00]')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_Next_UsageStatistic_Key00]
GO
CREATE PROCEDURE [dbo].[up_Next_UsageStatistic_Key00] @oldRecId integer AS
  DECLARE @oldModule char(20)
  DECLARE @oldAction char(20)
  SELECT @oldModule = Module, @oldAction = Action FROM [dbo].[ut_UsageStatistic] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00)
    WHERE (Module = @oldModule) AND (Action = @oldAction) AND (RecId > @oldRecId)
    ORDER BY Module,Action,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00)
    WHERE (Module = @oldModule) AND (Action > @oldAction)
    ORDER BY Module,Action,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00)
    WHERE (Module > @oldModule)
    ORDER BY Module,Action,RecId
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next_UsageStatistic_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_Next_UsageStatistic_Key00] @oldRecId integer AS EXECUTE [dbo].[up_Next_UsageStatistic_Key00] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_Prior_UsageStatistic_Key00]
GO
CREATE PROCEDURE [dbo].[up_Prior_UsageStatistic_Key00] @oldRecId integer AS
  DECLARE @oldModule char(20)
  DECLARE @oldAction char(20)
  SELECT @oldModule = Module, @oldAction = Action FROM [dbo].[ut_UsageStatistic] WHERE RecId = @oldRecId

  DECLARE @newRecId integer

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00)
    WHERE (Module = @oldModule) AND (Action = @oldAction) AND (RecId < @oldRecId)
    ORDER BY Module desc,Action desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00)
    WHERE (Module = @oldModule) AND (Action < @oldAction)
    ORDER BY Module desc,Action desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT TOP 1 @newRecId = ISNULL(RecId,0) FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00)
    WHERE (Module < @oldModule)
    ORDER BY Module desc,Action desc,RecId desc
  IF @newRecId <> 0 BEGIN
    SELECT @newRecId AS RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior_UsageStatistic_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_Prior_UsageStatistic_Key00] @oldRecId integer AS EXECUTE [dbo].[up_Prior_UsageStatistic_Key00] @oldRecId')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_Next50_UsageStatistic_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Next50_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[qp_Next50_UsageStatistic_Key00]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_Prior50_UsageStatistic_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_Prior50_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[qp_Prior50_UsageStatistic_Key00]
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_FindF_UsageStatistic_Key00]
GO
CREATE PROCEDURE [dbo].[up_FindF_UsageStatistic_Key00] @xKey char(250), @xLen integer AS
  DECLARE @mModule char(20) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,20)
  DECLARE @mAction char(20) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,21,20)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 40 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module = @mModule AND 
      Action = @mAction
      ORDER BY Module,Action,RecId
    RETURN
  END

  IF @xLen = 20 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module = @mModule
      ORDER BY Module,Action,RecId
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 20 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module >= @mModule AND SUBSTRING(Module,1,LEN(@mModule)) = @mModule
      ORDER BY Module,Action,RecId
    RETURN
  END

  IF @xLen < 40 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module = @mModule AND 
      Action >= @mAction AND SUBSTRING(Action,1,LEN(@mAction)) = @mAction
      ORDER BY Module,Action,RecId
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindF_UsageStatistic_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindF_UsageStatistic_Key00] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindF_UsageStatistic_Key00] @xKey, @xLen')
GO

IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_UsageStatistic_Key00')
  DROP PROCEDURE [dbo].[up_FindL_UsageStatistic_Key00]
GO
CREATE PROCEDURE [dbo].[up_FindL_UsageStatistic_Key00] @xKey char(250), @xLen integer AS
  DECLARE @mModule char(20) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,1,20)
  DECLARE @mAction char(20) = dbo.itcfunc_KeyToken_varchar(@xKey,@xLen,21,20)

  -- pass 1 -- Abfrage mit vollständigen Feldern (absteigende Vergleichslänge)

  IF @xLen = 40 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module = @mModule AND 
      Action = @mAction
      ORDER BY Module desc,Action desc,RecId desc
    RETURN
  END

  IF @xLen = 20 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module = @mModule
      ORDER BY Module desc,Action desc,RecId desc
    RETURN
  END

  -- pass 2 -- Abfrage mit teilweise unkompletten Felder (aufsteigende Vergleichslänge)

  IF @xLen < 20 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      SUBSTRING(Module,1,LEN(@mModule)) = @mModule
      ORDER BY Module desc,Action desc,RecId desc
    RETURN
  END

  IF @xLen < 40 BEGIN
    SELECT TOP 1 RecId FROM [dbo].[ut_UsageStatistic] WITH(INDEX = Ik_Key00) WHERE 
      Module = @mModule AND 
      SUBSTRING(Action,1,LEN(@mAction)) = @mAction
      ORDER BY Module desc,Action desc,RecId desc
    RETURN
  END

  SELECT 0 AS RecId
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'qp_FindL_UsageStatistic_Key00')
  EXEC('ALTER PROCEDURE [dbo].[qp_FindL_UsageStatistic_Key00] @xKey char(250), @xLen integer AS EXECUTE [dbo].[up_FindL_UsageStatistic_Key00] @xKey, @xLen')
GO


